summaryrefslogtreecommitdiffstats
path: root/armory
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2014-03-17 20:50:17 +0000
committer Eric Hameleers <alien@slackware.com>2014-03-17 20:50:17 +0000
commit5e4698f910b45acf74f73a372c1e371d5fd1e371 (patch)
tree85069920f6fdb3f275278270e480290135e8cfd2 /armory
parentc6875a55f05de2915ec7feed823fbe2d8a5b6f03 (diff)
downloadasb-5e4698f910b45acf74f73a372c1e371d5fd1e371.tar.gz
asb-5e4698f910b45acf74f73a372c1e371d5fd1e371.tar.xz
Initial revision
Diffstat (limited to 'armory')
-rwxr-xr-xarmory/build/armory.SlackBuild311
-rw-r--r--armory/build/armory_makefile.patch28
-rw-r--r--armory/build/slack-desc19
-rw-r--r--armory/build/slack-required5
4 files changed, 363 insertions, 0 deletions
diff --git a/armory/build/armory.SlackBuild b/armory/build/armory.SlackBuild
new file mode 100755
index 00000000..8900d465
--- /dev/null
+++ b/armory/build/armory.SlackBuild
@@ -0,0 +1,311 @@
+#!/bin/sh
+# $Id$
+# Copyright 2014 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: armory
+# Descr: python-based bitcoin software
+# URL: https://github.com/etotheipi/BitcoinArmory
+# Build needs:
+# Needs: bitcoin,cryptopp,python-psutil,python-twisted
+# Changelog:
+# 0.91-dev-1: 17/Mar/2014 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh armory.SlackBuild' to build a Slackware package.
+# The package (.tgz) and .txt file as well as build logs are created in /tmp .
+# Install it using 'installpkg'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=armory
+VERSION=${VERSION:-20140317}
+BRANCH="0.91-dev"
+PKGVERSION="$(echo $BRANCH |tr - _ )_${VERSION}"
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:" -j4 "}
+TAG=${TAG:-alien}
+
+DOCS="ABOUT* AUTHORS BUGS ChangeLog* COPYING CREDITS FAQ GPL* HACKING \
+ LICENSE MAINTAINERS NEWS README* TODO"
+
+PYTHON_SITELIB=$(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+# If you want automatic download to work, supply a URL for 'SRCURL' below:
+SOURCE="$SRCDIR/${PRGNAM}-${PKGVERSION}.tar.gz"
+SRCURL=""
+GITURI="git://github.com/etotheipi/BitcoinArmory.git"
+
+# Use the src_checkout() function if no downloadable tarball exists.
+# This function checks out sources from GIT and creates a tarball of them.
+src_checkout() {
+ # Param #1 : index in the SOURCE[] array.
+ # Param #2 : full path to where SOURCE[$1] tarball should be created.
+ # Determine the tarball extension:
+ PEXT=$(echo "${2}" | sed -r -e 's/.*[^.].(tar.xz|tar.gz|tar.bz2|tgz).*/\1/')
+ case "$PEXT" in
+ "tar.xz") TARCOMP="J" ;;
+ "tar.gz") TARCOMP="z" ;;
+ "tgz") TARCOMP="z" ;;
+ "tar.bz2") TARCOMP="j" ;;
+ *) echo "Archive can only have extension 'tar.xz', '.tar.gz' '.tar.bz2' or '.tgz'" ; exit 1 ;;
+ esac
+ # Determine the directory name to create for the archive root:
+ PBASE=$(basename ${2} .${PEXT})
+ # Determine the directory where we create our checkout:
+ CODIR=$(dirname ${2})
+ case ${1} in
+ 0) # GIT checkout:
+ RETDIR=$(pwd)
+ mkdir -p $CODIR/${PRGNAM}_temp_checkout_$$ \
+ && cd $CODIR/${PRGNAM}_temp_checkout_$$
+ mkdir ${PBASE} \
+ && git clone ${GITURI} ${PBASE} \
+ && cd ${PBASE} \
+ && git checkout master \
+ && git checkout $(git rev-list -n 1 --before="`date -d $VERSION`" $BRANCH) \
+ && cd .. \
+ && chown -R root:root ${PBASE} \
+ && tar --exclude .git -${TARCOMP}cf ${2} ${PBASE}
+ cd $RETDIR
+ rm -rf $CODIR/${PRGNAM}_temp_checkout_$$ || true
+ ;;
+ *) # Do nothing
+ ;;
+ esac
+}
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Automatically determine the architecture we're building on:
+MARCH=$( uname -m )
+if [ -z "$ARCH" ]; then
+ case "$MARCH" in
+ i?86) export ARCH=i486 ;;
+ armv7hl) export ARCH=$MARCH ;;
+ armv6hl) export ARCH=$MARCH ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$MARCH ;;
+ esac
+fi
+
+case "$ARCH" in
+ i486) SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ armv6hl) SLKCFLAGS="-O2 -march=armv6 -mfpu=vfp -mfloat-abi=hard"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ *) SLKCFLAGS=${SLKCFLAGS:-"O2"}
+ SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+ ;;
+esac
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{configure,make,install,error,makepkg,patch}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename ${SOURCE})"
+ if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE)"
+ wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Fail to download '$(basename ${SOURCE})'. Aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ # Try if we have a SVN/CVS download routine for ${SOURCE}
+ echo "Will checkout sources to $(dirname $SOURCE)"
+ src_checkout 0 "${SOURCE}" 2>&1 > $OUTPUT/checkout-$(basename ${SOURCE}).log
+ fi
+ if [ ! -f "${SOURCE}" -o ! -s "${SOURCE}" ]; then
+ echo "File '$(basename ${SOURCE})' not available. Aborting the build."
+ exit 1
+ fi
+fi
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$PKGVERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE}
+cd ${PRGNAM}-${PKGVERSION}
+
+# Fix up the Makefile for our CXXFLAGS:
+cat $SRCDIR/armory_makefile.patch | patch -p1 --verbose \
+ 2>&1 | tee $OUTPUT/patch-${PRGNAM}.log
+sed -e "s/^CFLAGS=-g.*$/CFLAGS=-g3 -Wall $SLKCFLAGS/" \
+ -e "s/^CXXFLAGS=-g.*$/CXXFLAGS=-g3 -Wall $SLKCFLAGS/" \
+ -e "s/^CFLAGS=-[^g].*$/CFLAGS=$SLKCFLAGS/" \
+ -e "s/^CXXFLAGS=-[^g].*$/CXXFLAGS=$SLKCFLAGS/" \
+ -i cppForSwig/Makefile
+
+# Fix up the desktop files;
+sed -i "s,python /usr/lib/,python ${PYTHON_SITELIB}/," \
+ dpkgfiles/*.desktop
+
+chown -R root:root .
+chmod -R u+w,go+r-w,a+rX-st .
+
+echo Building ...
+#make $NUMJOBS CFLAGS="${SLKCFLAGS}" CXXFLAGS="${SLKCFLAGS}" \
+make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+
+# Create desktop menu entries:
+mkdir -p $PKG/usr/share/{applications,pixmaps}
+install -m0644 img/armory_icon_64x64.png $PKG/usr/share/pixmaps/armoryicon.png
+install -m0644 img/armory_icon_64x64.png $PKG/usr/share/pixmaps/armoryofflineicon.png
+install -m0644 img/armory_icon_green_64x64.png $PKG/usr/share/pixmaps/armorytestneticon.png
+install -m0644 dpkgfiles/*.desktop $PKG/usr/share/applications/
+
+# Startup wrapper:
+mkdir -p $PKG/usr/bin
+cat <<EOT > $PKG/usr/bin/armory
+#!/bin/sh
+python ${PYTHON_SITELIB}/armory/ArmoryQt.py $@
+EOT
+chmod 755 $PKG/usr/bin/armory
+
+# Application images:
+mkdir -p $PKG/usr/share/armory/img
+install -m0644 img/* $PKG/usr/share/armory/img/
+
+# All the python code:
+mkdir -p $PKG/${PYTHON_SITELIB}/armory/{extras,jsonrpc,dialogs}
+install -m0644 *.py README $PKG/${PYTHON_SITELIB}/armory/
+install -m0755 *.so README $PKG/${PYTHON_SITELIB}/armory/
+install -m0644 extras/*.py $PKG/${PYTHON_SITELIB}/armory/extras/
+install -m0644 jsonrpc/*.py $PKG/${PYTHON_SITELIB}/armory/jsonrpc
+install -m0644 dialogs/*.py $PKG/${PYTHON_SITELIB}/armory/dialogs
+
+# Add this to the doinst.sh:
+mkdir -p $PKG/install
+cat <<EOINS >> $PKG/install/doinst.sh
+# Update the desktop database:
+if [ -x usr/bin/update-desktop-database ]; then
+ chroot . /usr/bin/update-desktop-database usr/share/applications > /dev/null 2>&1
+fi
+
+# Update hicolor theme cache:
+if [ -d usr/share/icons/hicolor ]; then
+ if [ -x /usr/bin/gtk-update-icon-cache ]; then
+ chroot . /usr/bin/gtk-update-icon-cache -f -t usr/share/icons/hicolor 1> /dev/null 2> /dev/null
+ fi
+fi
+
+# Update the mime database:
+if [ -x usr/bin/update-mime-database ]; then
+ chroot . /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
+fi
+
+EOINS
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$PKGVERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$PKGVERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$PKGVERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$PKGVERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/slack-required > $PKG/install/slack-required
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${PKGVERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${PKGVERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${PKGVERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${PKGVERSION}-${ARCH}-${BUILD}${TAG}.txt
+cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${PKGVERSION}-${ARCH}-${BUILD}${TAG}.dep
+
+# Restore the original umask:
+umask ${_UMASK_}
+
diff --git a/armory/build/armory_makefile.patch b/armory/build/armory_makefile.patch
new file mode 100644
index 00000000..18522757
--- /dev/null
+++ b/armory/build/armory_makefile.patch
@@ -0,0 +1,28 @@
+diff -uar armory-0.91-dev_20140317.orig/cppForSwig/cryptopp/Makefile armory-0.91-dev_20140317/cppForSwig/cryptopp/Makefile
+--- armory-0.91-dev_20140317.orig/cppForSwig/cryptopp/Makefile 2014-03-17 11:35:54.000000000 +0100
++++ armory-0.91-dev_20140317/cppForSwig/cryptopp/Makefile 2014-03-17 11:57:27.605968313 +0100
+@@ -1,4 +1,4 @@
+-CXXFLAGS = -DNDEBUG -g -O2
++CXXFLAGS += -DNDEBUG
+ #CXXFLAGS = -g
+ # -fPIC is supported. Please report any breakage of -fPIC as a bug.
+ CXXFLAGS += -fPIC
+@@ -36,9 +36,6 @@
+ ifneq ($(GCC42_OR_LATER),0)
+ ifeq ($(UNAME),Darwin)
+ CXXFLAGS += -arch x86_64 -arch i386
+-else
+-#CXXFLAGS += -march=native
+-CXXFLAGS += -mtune=generic
+ endif
+ endif
+
+@@ -74,8 +71,6 @@
+
+ ifeq ($(UNAME),) # for DJGPP, where uname doesn't exist
+ CXXFLAGS += -mbnu210
+-else
+-CXXFLAGS += -pipe
+ endif
+
+ ifeq ($(UNAME),Linux)
diff --git a/armory/build/slack-desc b/armory/build/slack-desc
new file mode 100644
index 00000000..2b48c635
--- /dev/null
+++ b/armory/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+armory: armory (python-based bitcoin software)
+armory:
+armory:
+armory:
+armory:
+armory:
+armory:
+armory:
+armory:
+armory: armory home: https://github.com/etotheipi/BitcoinArmory
+armory:
diff --git a/armory/build/slack-required b/armory/build/slack-required
new file mode 100644
index 00000000..cf7911c7
--- /dev/null
+++ b/armory/build/slack-required
@@ -0,0 +1,5 @@
+bitcoin
+cryptopp
+python-psutil
+python-twisted
+